<?php

namespace App\Http\Controllers;

use App\Models\Medio;
use Illuminate\Http\Request;

use Illuminate\Routing\Controller;
class MedioController extends Controller
{

    public function __construct() {
        $this->middleware('can:medio.index')->only('index','show');
        $this->middleware('can:medio.create')->only('create','store');
        $this->middleware('can:medio.edit')->only('edit','update');
        $this->middleware('can:medio.destroy')->only('destroy');
    }

    public function index()
    {
        $medios = Medio::all();
        return view('medio.index',compact('medios'));
    }

    public function create()
    {
        return view('medio.create');
    }


    public function store(Request $request)
    {
        $request->validate([
            'name'=>'required'
        ]);

        $medio = Medio::create($request->all());
        return redirect()->route('medio.edit',$medio)->with('info','El medio se creo correctamente');
    }


    public function show(Medio $medio)
    {

        return view('medio.show',compact('medio'));
    }


    public function edit(Medio $medio)
    {
        return view('medio.edit',compact('medio'));
    }


    public function update(Request $request, Medio $medio)
    {
        $medio->update($request->all());
        return redirect()->route('medio.edit',$medio)->with('info','El medio se actualizo correctamente');
    }

    public function destroy(Medio $medio)
    {
        $medio->delete();
        session()->flash('swal',[
            'icon'=>'success',
            'title'=>'Eliminado!',
            'text'=>'Se ha eliminado el registro correctamente'
        ]);
        return redirect()->route('medio.index');
    }
}
